import markdown

from markdown import Extension
from markdown.inlinepatterns import InlineProcessor

import xml.etree.ElementTree as etree

class SourceLinker(InlineProcessor):
    def handleMatch(self, m, data):
        supElem = etree.Element("sup")
        aElem = etree.SubElement(supElem, "a")
        aElem.attrib["href"] = "#source"+m.group(1)
        aElem.text = "["+m.group(1)+"]"
        return supElem, m.start(0), m.end(0)
        

class ArticleMarkdown(Extension):
    def extendMarkdown(self, md):
        md.inlinePatterns.register(SourceLinker(r'\[\^(\d+)\]', md), "sourceLinker", 175)